if select(2, UnitClass("player")) ~= "ROGUE" then return end
local GetSpellInfo = DrDamage.SafeGetSpellInfo
local GetSpellCritChance = GetSpellCritChance
local GetCritChance = GetCritChance
local UnitDebuff = UnitDebuff
local UnitCreatureType = UnitCreatureType
local math_min = math.min
local math_max = math.max
local math_floor = math.floor
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitDamage = UnitDamage
local string_find = string.find
local string_lower = string.lower
local IsEquippedItemType = IsEquippedItemType
local ipairs = ipairs
local select = select

function DrDamage:PlayerData()
	--Health Updates
	self.TargetHealth = { [1] = 0.35, [2] = "player" }
	--Special aura handling
	local TargetIsPoisoned = false
	local Mutilate = GetSpellInfo(1329)
	local poison = GetSpellInfo(38615)
	self.Calculation["TargetAura"] = function()
		local temp = TargetIsPoisoned
		TargetIsPoisoned = false

		for i=1,40 do
			local name, _, _, _, debuffType = UnitDebuff("target",i)
			if name then
				if debuffType == poison then
					TargetIsPoisoned = true
					break
				end
			else break end
		end
		if temp ~= TargetIsPoisoned then
			return true, Mutilate
		end
	end
--GENERAL
	--TODO: Poisons
	local instant = GetSpellInfo(8679)
	local wound = GetSpellInfo(13219)
	local deadly = GetSpellInfo(2823)
	--local ohs = GetSpellInfo(201)
	--local oha = GetSpellInfo(196)
	local ipicon = "|T" .. select(3,GetSpellInfo(8679)) .. ":16:16:1:1|t"
	local wpicon = "|T" .. select(3,GetSpellInfo(13219)) .. ":16:16:1:1|t"
	local dpicon = "|T" .. select(3,GetSpellInfo(2823)) .. ":16:16:1:-1|t"
	--local hasicon = "|T" .. select(3,GetSpellInfo(13960)) .. ":16:16:1:1|t"
	self.Calculation["ROGUE"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		--Specialization
		local spec = GetPrimaryTalentTree()
		local mastery = GetMastery()
		if spec == 1 then
			calculation.poisonBonus = 1.28 + 3.5/100 * mastery
		elseif spec == 2 then
			calculation.offHdmgM = calculation.offHdmgM * 1.75
			if calculation.group == "Ranged" then
				calculation.wDmgM = calculation.wDmgM * 1.74
			end
			--TODO: Main gauche?
			--Your main hand attacks have a 16% chance to grant you an extra off hand attack.  
			--Each point of Mastery increases the chance by an additional 2.00%.
			--[[
			if Talents["Hack and Slash"] then
				--"Attack", "Sinister Strike", "Eviscerate", "Fan of Knives", "Envenom", "Shiv", "Ghostly Strike", "Gouge", "Rupture", "Hemorrhage"
				--Requires One-Handed Swords
				local mhType, ohType = self:GetWeaponType()
				local mh = ((mhType == ohs) or (mhType == oha)) and not baseSpell.OffhandAttack
				local oh = ((ohType == ohs) or (ohType == oha)) and (baseSpell.AutoAttack or baseSpell.OffhandAttack or baseSpell.DualAttack)
				if mh or oh then
					if not calculation.extraDamage then			
						calculation.extraDamage = 0
					end
					calculation.extraWeaponDamage = 1
					calculation.extraWeaponDamageM = true
					calculation.extraWeaponDamageChance = (mh and oh) and (2 * Talents["Hack and Slash"]) or Talents["Hack and Slash"]
					calculation.extraWeaponDamage_dmgM = calculation.dmgM_global
					calculation.extra_canCrit = true
					calculation.extra_critM = 1 + 2 * self.Damage_critMBonus
					calculation.extra_critPerc = GetCritChance() + calculation.meleeCrit
					calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. hasicon) or hasicon
				end
			end
			--]]			
		elseif spec == 3 then
			if calculation.spellName == "Backstab" or calculation.spellName == "Hemorrhage" then
				--TODO: Additive or multiplicative?
				calculation.WeaponDamage = calculation.WeaponDamage + 0.25
			end
			if baseSpell.Finisher then
				calculation.dmgM = calculation.dmgM * (1.16 + 2/100 * mastery)
			end
			--TODO: Master of Subtlety? Slice and Dice bonus?
		end
		--[[
		if Talents["Focused Attacks"] then
			calculation.actionCost = calculation.actionCost - 2 * Talents["Focused Attacks"] * (calculation.critPerc / 100) * (baseSpell.DualAttack and not baseSpell.AoE and 2 or 1)
		end
		--]]
		if Talents["Sanguinary Vein"] and ActiveAuras["Bleeding"] then
			--TODO: Verify
			calculation.dmgM = calculation.dmgM * (1 + Talents["Sanguinary Vein"])
		end
		if ActiveAuras["Blade Flurry"] then
			if not calculation.aoe then
				calculation.aoe = 2
			else
				calculation.targets = calculation.targets * 2
			end
		end
		local buff = self:GetWeaponBuff()
		local buffO = self:GetWeaponBuff(true)
		local hit
		if buff or buffO then
			calculation.E_dmgM = select(7,UnitDamage("player")) * (1 + (Talents["Vile Poisons"] or 0)) * calculation.dmgM_Magic * (calculation.poisonBonus or 1)
			calculation.E_canCrit = true
			calculation.E_critPerc = GetSpellCritChance(4) + calculation.spellCrit
			calculation.E_critM = 0.5 + self.Damage_critMBonus * 1.5
			hit = 0.01 * math_max(0,math_min(100, self:GetSpellHit(calculation.playerLevel,calculation.targetLevel) + calculation.spellHit))
		end
		if not baseSpell.OffhandAttack and not baseSpell.NoPoison and buff then
			--Instant Poison
			if buff == instant then
				local spd = self:GetWeaponSpeed()
				calculation.extra = 0 --TODO: damage
				calculation.extraDamage = 0.09
				calculation.extraChance = 0.2/1.4 * spd * (1 + (calculation.poisonBonus and 0.5 or 0) + (ActiveAuras["Envenom"] and 0.75 or 0)) * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. ipicon) or ipicon
			--Wound Poison
			elseif buff == wound then
				local spd = self:GetWeaponSpeed()
				calculation.extra = 0 --TODO: damage
				calculation.extraDamage = 0.036
				calculation.extraChance = 0.5/1.4 * spd * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. wpicon) or wpicon
			--Anesthethic Poison
			--[[
			elseif anesthetic[buff] then
				calculation.extra = anesthetic[buff]
				calculation.extraChance = 0.5 * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. apicon) or apicon
				if not calculation.extraDamage then
					calculation.extraDamage = 0
				end
			--]]
			--Deadly Poison
			elseif baseSpell.AutoAttack and buff == deadly then
				calculation.extra_DPS = 0 --TODO: damage
				calculation.extraDamage_DPS = 0.108
				calculation.extraDuration_DPS = 12
				calculation.extraStacks_DPS = 5
				calculation.extraName_DPS = "5x" .. dpicon
			end
		end
		if (baseSpell.AutoAttack or baseSpell.DualAttack or baseSpell.OffhandAttack) and buffO then
			--Instant Poison
			if buffO == instant then
				local _, spd = self:GetWeaponSpeed()
				calculation.extra_O = 0 -- TODO: damage
				calculation.extraDamage_O = 0.09
				calculation.extraChance_O = 0.2/1.4 * spd * (1 + (calculation.poisonBonus and 0.5 or 0) + (ActiveAuras["Envenom"] and 0.75 or 0)) * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. ipicon) or ipicon
				if not calculation.extraDamage then
					calculation.extraDamage = 0
				end
			--Wound Poison
			elseif buffO == wound then
				local _, spd = self:GetWeaponSpeed()
				calculation.extra_O = 0 --TODO: damage
				calculation.extraDamage_O = 0.036
				calculation.extraChance_O = 0.5/1.4 * spd * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. wpicon) or wpicon			
				if not calculation.extraDamage then
					calculation.extraDamage = 0
				end
			--Anesthethic Poison
			--[[
			elseif anesthetic[buffO] then
				calculation.extra_O = anesthetic[buffO]
				calculation.extraChance_O = 0.5 * hit
				calculation.extraName = calculation.extraName and (calculation.extraName .. "+" .. apicon) or apicon
				if not calculation.extraDamage then
					calculation.extraDamage = 0
				end
			--Deadly Poison
			--]]
			elseif baseSpell.AutoAttack and deadly[buffO] then
				calculation.extra_DPS = 0 --TODO damage
				calculation.extraDamage_DPS = 0.108
				calculation.extraDuration_DPS = 12
				calculation.extraStacks_DPS = 5
				calculation.extraName_DPS = "5x" .. dpicon
			end
		end
	end
--TALENTS
	--[[
	local ohm = GetSpellInfo(198)
	self.Calculation["Mace Specialization"] = function( calculation, value )
		if IsEquippedItemType(ohm) then
			calculation.armorPen = calculation.armorPen + value
		end
	end
	self.Calculation["Surprise Attacks"] = function( calculation, value )
		calculation.NoDodge = true
	end
	--]]
	self.Calculation["Relentless Strikes"] = function( calculation, value )
		calculation.actionCost = calculation.actionCost - value * calculation.Melee_ComboPoints * 25
	end	
--ABILITIES
	self.Calculation["Shiv"] = function( calculation, _, Talents )
		calculation.extraChance_O = 0.01 * math_max(0,math_min(100, self:GetSpellHit(calculation.playerLevel,calculation.targetLevel) + calculation.spellHit))
		calculation.E_canCrit = false
		if Talents["Combat Potency"] then
			calculation.actionCost = calculation.actionCost - Talents["Combat Potency"] * 0.2 * (calculation.hitO / 100)
		end
	end
	self.Calculation["Fan of Knives"] = function( calculation )
		if self:GetNormM() == 1.7 then
			calculation.WeaponDamage = 1.05
		end
	end
	self.Calculation["Envenom"] = function( calculation, ActiveAuras, _, spell )
		if ActiveAuras["Deadly Poison"] then
			local cp = math_min(ActiveAuras["Deadly Poison"], calculation.Melee_ComboPoints)
			if cp > 1 then
				calculation.minDam = calculation.minDam + (cp - 1) * spell.DPBonus
				calculation.maxDam = calculation.maxDam + (cp - 1) * spell.DPBonus
			end
		else
			calculation.zero = true
		end
	end
	self.Calculation["Mutilate"] = function( calculation, _, Talents )
		if TargetIsPoisoned then
			--Multiplicative - 3.3.3
			calculation.dmgM = calculation.dmgM * 1.2
		end
		if self:GetSetAmount("T9") >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
		if Talents["Combat Potency"] then
			calculation.actionCost = calculation.actionCost - Talents["Combat Potency"] * 0.2 * (calculation.hitO / 100)
		end		
	end
	self.Calculation["Killing Spree"] = function( calculation, ActiveAuras )
		if not ActiveAuras["Killing Spree"] then
			--Glyph of Killing Spree (4.0)
			calculation.dmgM = calculation.dmgM * (1.2 + (self:HasGlyph(63252) and 0.1 or 0))
		end
	end
	self.Calculation["Eviscerate"] = function( calculation )
		--Glyph of Eviscerate (4.0)
		if self:HasGlyph(56802) then
			calculation.critPerc = calculation.critPerc + 10
		end
	end
	self.Calculation["Ghostly Strike"] = function( calculation )
		if self:GetNormM() == 1.7 then
			calculation.WeaponDamage = 1.8
		end		
	end
	self.Calculation["Rupture"] = function( calculation )
		--Glyph of Rupture (4.0)
		if self:HasGlyph(56801) then
			calculation.eDuration = calculation.eDuration + 4
		end
		if self:GetSetAmount("T7") >= 2 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		if self:GetSetAmount("T8") >= 4 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.2
		end
	end
	self.Calculation["Hemorrhage"] = function( calculation )
		if self:GetSetAmount("T9") >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
		if self:GetNormM() == 1.7 then
			--TODO: Verify
			calculation.WeaponDamage = 1.6
		end
		--Glyph of Hemorrhage (4.0)
		if self:HasGlyph(56807) then
			--TODO: Your Hemorrhage ability also causes the target to bleed, dealing 40% of the direct strike's damage over 24 sec.
		end		
	end
	self.Calculation["Sinister Strike"] = function( calculation )
		if self:GetSetAmount("T9") >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	self.Calculation["Backstab"] = function( calculation, _, Talents )
		if self:GetSetAmount("T9") >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
		--Glyph of Backstab (4.0)
		if self:HasGlyph(56800) then
			calculation.actionCost = calculation.actionCost - 5 * (calculation.critPerc / 100)
		end		
		if Talents["Murderous Intent"] and UnitHealth("target") ~= 0 and (UnitHealth("target") / UnitHealthMax("target")) < 0.35 then
			calculation.actionCost = calculation.actionCost - Talents["Murderous Intent"] 
		end
	end
	self.Calculation["Ambush"] = function( calculation )
		if self:GetNormM() == 1.7 then
			calculation.WeaponDamage = 2.75
			calculation.minDam = calculation.minDam * 1.447
			calculation.maxDam = calculation.maxDam * 1.447
		end	
	end
--SETS
	self.SetBonuses["T7"] = { 40495, 40496, 40499, 40500, 40502, 39558, 39560, 39561, 39564, 39565 }
	self.SetBonuses["T8"] = { 46123, 46124, 46125, 46126, 46127, 45396, 45397, 45398, 45399, 45400 }
	self.SetBonuses["T9"] = { 48243, 48244, 48245, 48246, 48247, 48218, 48219, 48220, 48221, 48222, 48223, 48224, 48225, 48226, 48227, 48232, 48231, 48230, 48229, 48228, 48242, 48241, 48240, 48239, 48238, 48233, 48234, 48235, 48236, 48237 }
	self.SetBonuses["T10"] = { 50150, 50090, 50089, 50088, 50087, 51185, 51254, 51186, 51253, 51187, 51252, 51188, 51251, 51189, 51250 }
--AURA
--Player
	--Killing Spree (4.0, VERIFY)
	self.PlayerAura[GetSpellInfo(51690)] = { ActiveAura = "Killing Spree", ID = 51690, ModType =
		function( calculation )
			--Glyph of Killing Spree (4.0)
			calculation.dmgM = calculation.dmgM * (1.2 + (self:HasGlyph(63252) and 0.1 or 0))
		end
	}
	--Remorseless
	--self.PlayerAura[GetSpellInfo(14143)] = { ActiveAura = "Remorseless", ID = 14143 }
	--Shadowstep (4.0)
	self.PlayerAura[GetSpellInfo(36554)] = { ActiveAura = "Shadowstep", Value = 0.3, ID = 36554, Spells = { 8676, 703 } }
	--Envenom (4.0)
	self.PlayerAura[GetSpellInfo(32645)] = { ActiveAura = "Envenom", Spells = 6603, ID = 32645 }
	--Turn the Tables
	--self.PlayerAura[GetSpellInfo(51629)] = { ModType = "critPerc", Ranks = 3, Value = 2, ID = 51629, Spells = { 53, 31022, 16511, 1329, 14251, 5938, 1752 } }
	--Blade Flurry (4.0)
	self.PlayerAura[GetSpellInfo(13877)] = { ActiveAura = "Blade Flurry", ID = 13877, }
	--Slice and Dice (4.0)
	self.PlayerAura[GetSpellInfo(5171)] = { ID = 5171, Mods = { ["haste"] = function(v) return v * 1.4 end } }
	--Cold Blood (4.0)
	self.PlayerAura[GetSpellInfo(14177)] = { Value = 100, ModType = "critPerc", ID = 14177, Not = { "Attack", "Rupture", "Garrote", "Gouge", "Shiv" } }
	--Shallow Insight
	self.PlayerAura[GetSpellInfo(84745)] = { SelfCast = true, ID = 84745, Category = "Bandit's Guile", Value = 0.1 }
	--Moderate Insight
	self.PlayerAura[GetSpellInfo(84746)] = { SelfCast = true, ID = 84746, Category = "Bandit's Guile", Value = 0.2 }
	--Deep Insight
	self.PlayerAura[GetSpellInfo(84747)] = { SelfCast = true, ID = 84747, Category = "Bandit's Guile", Value = 0.3 }
--Target
	--Deadly Poison (4.0)
	self.TargetAura[GetSpellInfo(2818)] = { ActiveAura = "Deadly Poison", Spells = { 32645, 1329 }, SelfCast = true, Apps = 5, ID = 2818 }
	--Vendetta (4.0)
	self.TargetAura[GetSpellInfo(79140)] = { SelfCast = true, ID = 79140, Value = 0.2 }
	--Revealing Strike (4.0, TODO: Verify spells)
	self.TargetAura[GetSpellInfo(84617)] = { SelfCast = true, ID = 84617, Spells = { 2098, 1943, 32645, 26679 }, ModType = 
		function(calculation )
			--Glyph of Revealing Strike (4.0)
			calculation.dmgM = calculation.dmgM * (1.2 + (self:HasGlyph(56814) and 0.1 or 0))
		end
	}
	--Find Weakness (4.0)
	self.TargetAura[GetSpellInfo(91023)] = { Ranks = 2, Value = 0.25, ModType = "armorM", ID = 91023 }
--Bleed effects (TODO: Verify)
	--Deep Wound
	self.TargetAura[GetSpellInfo(43104)] = 	{ ActiveAura = "Bleeding", Manual = "Bleeding", ID = 59881 }
	--Rend
	self.TargetAura[GetSpellInfo(16403)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Garrote
	self.TargetAura[GetSpellInfo(703)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Rupture
	self.TargetAura[GetSpellInfo(1943)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Lacerate
	self.TargetAura[GetSpellInfo(33745)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Pounce
	self.TargetAura[GetSpellInfo(9005)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Rip
	self.TargetAura[GetSpellInfo(1079)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Rake
	self.TargetAura[GetSpellInfo(59881)] = 	self.TargetAura[GetSpellInfo(43104)]
	--Piercing Shots
	self.TargetAura[GetSpellInfo(53234)] = 	self.TargetAura[GetSpellInfo(43104)]	
	
	self.spellInfo = {
		[GetSpellInfo(1752)] = {
			["Name"] = "Sinister Strike",
			["Base"] = function() return self:ScanTooltip(1752) end,
			[0] = { WeaponDamage = 1 },
			[1] = { 0 },
		},
		[GetSpellInfo(53)] = {
			["Name"] = "Backstab",
			["Base"] = function() return self:ScanTooltip(53) end,
			[0] = { WeaponDamage = 2, Weapon = GetSpellInfo(1180) }, --Daggers
			[1] = { 0 },
		},
		[GetSpellInfo(2098)] = {
			["Name"] = "Eviscerate",
			["Base"] = function(path)
				local min, max = self:ScanTooltip(2098, true, 1)
				local min2, max2 = self:ScanTooltip(2098, true, 2)
				path.PerCombo = min2 - min
				return min, max
			end,
			[0] = { ComboPoints = true, APBonus = { 0.091, 0.182, 0.273, 0.364, 0.455 }, Finisher = true },
			[1] = { 0, 0, PerCombo = 0 },
		},
		[GetSpellInfo(8676)] = {
			["Name"] = "Ambush",
			["Base"] = function() return self:ScanTooltip(8676) end,
			[0] = { WeaponDamage = 1.9, Weapon = GetSpellInfo(1180), Unavoidable = true }, --Daggers
			[1] = { 0 },
		},
		[GetSpellInfo(1776)] = {
			["Name"] = "Gouge",
			["Base"] = function() return self:ScanTooltip(1776, false, false, 10) end,
			[0] = { APBonus = 0.21, NoPoison = true, Cooldown = 10 },
			[1] = { 0 },
		},
		[GetSpellInfo(703)] = {
			["Name"] = "Garrote",
			["Base"] = function() return self:ScanTooltip(703, false, false, 18) end,
			[0] = { NoCrits = true, APBonus = 0.42, eDuration = 18, Ticks = 3, NoWeapon = true, Bleed = true, Unavoidable = true },
			[1] = { 0 },
		},		
		[GetSpellInfo(1943)] = {
			["Name"] = "Rupture",
			["Base"] = function(path)
				local min, max = self:ScanTooltip(1943, false, 1, 16)
				local min2, max2 = self:ScanTooltip(1943, false, 2, 16)
				path.PerCombo = min2 - min
				return min, max
			end,			
			[0] = { ComboPoints = true, APBonus = { 0.06, 0.12, 0.18, 0.24, 0.3 }, --[[ExtraPerCombo = { 0, 0, 1, 3, 6 },--]] eDuration = 6, Ticks = 2, DurationPerCombo = 2, Bleed = true, Finisher = true },
			[1] = { 0, PerCombo = 0, --[[ExtraPerCombo = 4--]] },
		},
		[GetSpellInfo(16511)] = {
			["Name"] = "Hemorrhage",
			[0] = { WeaponDamage = 1.1 },
			[1] = { 0 },
		},
		[GetSpellInfo(5938)] = {
			["Name"] = "Shiv",
			[0] = { WeaponDamage = 1, OffhandAttack = true, NoCrits = true, Unavoidable = true },
			[1] = { 0 },
		},
		[GetSpellInfo(32645)] = {
			["Name"] = "Envenom",
			["Base"] = function(path)
				local min, max = self:ScanTooltip(32645, false, 1, 5)
				local min2, max2 = self:ScanTooltip(32645, false, 2, 5)
				path.DPBonus = min2 - min
				return min, max
			end,			
			[0] = { School = "Nature", ComboPoints = true, APBonus = { 0.09, 0.18, 0.27, 0.36, 0.45 }, Finisher = true },
			[1] = { 0, DPBonus = 0 },
		},
		[GetSpellInfo(26679)] = {
			["Name"] = "Deadly Throw",
			["Base"] = function(path)
				local min, max = self:ScanTooltip(26679, true, 1)
				local min2, max2 = self:ScanTooltip(26679, true, 2)
				path.DPBonus = min2 - min
				return min, max
			end,			
			[0] = { School = { "Physical", "Ranged" }, ComboPoints = true, WeaponDamage = 1, NoPoison = true, NoNormalization = true, Finisher = true },
			[1] = { 0, 0, PerCombo = 0 },
		},
		[GetSpellInfo(1329)] = {
			["Name"] = "Mutilate",
			["Base"] = function() return self:ScanTooltip(1329) end,
			[0] = { WeaponDamage = 1.5, DualAttack = true, Weapon = GetSpellInfo(1180) }, --Daggers
			[1] = { 0 },
		},
		[GetSpellInfo(51723)] = {
			["Name"] = "Fan of Knives",
			[0] = { School = { "Physical", "Ranged" }, WeaponDamage = 0.8, --[[DualAttack = true,--]] AoE = true, NoNormalization = true },
			[1] = { 0 },
		},
		[GetSpellInfo(51690)] = {
			["Name"] = "Killing Spree",
			[0] = { WeaponDamage = 1, DualAttack = true, Hits = 5 },
			[1] = { 0 },
		},
		[GetSpellInfo(84617)] = {
			["Name"] = "Revealing Strike",
			[0] = { WeaponDamage = 1.25, NoNormalization = true, },
			[1] = { 0 },
		},		
	}
	self.talentInfo = {
	--ASSASSINATION:
		--Coup de Grace (additive - 3.3.3)
		[GetSpellInfo(14162)] = {	[1] = { Effect = { 0.07, 0.14, 0.20 } , Spells = { "Eviscerate", "Envenom" }, }, },
		--Lethality
		[GetSpellInfo(14128)] = {	[1] = { Effect = 0.1, Spells = { "Sinister Strike", "Backstab", "Mutilate", "Hemorrhage" }, ModType = "critM" }, },		
		--Puncturing Wounds
		[GetSpellInfo(13733)] = {	[1] = { Effect = 10, Spells = "Backstab", ModType = "critPerc" },
									[2] = { Effect = 5, Spells = "Mutilate", ModType = "critPerc" }, },		
		--Vile Poisons (additive - 3.3.3)
		[GetSpellInfo(16513)] = {	[1] = { Effect = { 0.07, 0.14, 0.20 }, Spells = "All", ModType = "Vile Poisons" }, 
									[2] = { Effect = { 0.33, 0.66, 1 }, Spells = "Fan of Knives", ModType = "Poison Chance" }, },
		--Murderous Intent
		[GetSpellInfo(14518)] = {	[1] = { Effect = 15, Spells = "Backstab", ModType = "Murderous Intent" }, },
		--TODO: Venomous Wounds
		[GetSpellInfo(79133)] = {	[1] = { Effect = 0.3, Spells = { "Rupture", "Garrote" }, ModType = "Venomous Wounds" }, },
	--COMBAT:
		--Improved Sinister Strike (additive?)
		[GetSpellInfo(13732)] = {	[1] = { Effect = 0.1, Spells = "Sinister Strike", }, },
		--Precision
		[GetSpellInfo(13705)] = {	[1] = { Effect = 2, Spells = "All", ModType = "hitPerc" },
									[2] = { Effect = 2, Spells = "All", ModType = "spellHit" }, },
		--Aggression (additive - 3.3.3)
		[GetSpellInfo(18427)] = {	[1] = { Effect = { 0.07, 0.14, 0.20 }, Spells = { "Sinister Strike", "Eviscerate", "Backstab" } }, },									
		--Combat Potency
		[GetSpellInfo(35551)] = {	[1] = { Effect = 5, Spells = { "Shiv", "Mutilate", }, ModType = "Combat Potency" }, },
	--SUBTLETY:
		--Improved Ambush (additive?)
		[GetSpellInfo(14079)] = {	[1] = { Effect = 20, Spells = "Ambush", ModType = "critPerc" }, 
									[2] = { Effect = 0.05, Spells = "Ambush" }, },
		--Relentless Strikes
		[GetSpellInfo(14179)] = {	[1] = { Effect = { 0.07, 0.14, 0.20 }, Spells = { "Eviscerate", "Deadly Throw", "Envenom", "Rupture" }, ModType = "Relentless Strikes", }, },
		--Opportunity (additive - 3.3.3)
		[GetSpellInfo(14057)] = {	[1] = { Effect = 0.1, Spells = { "Backstab", "Mutilate", "Garrote", "Ambush" } }, },
		--Sanguinary Vein (multiplicative?)
		[GetSpellInfo(79146)] = {	[1] = { Effect = 0.05, Spells = "All", ModType = "Sanguinary Vein" }, },
	}
end