if select(2, UnitClass("player")) ~= "WARLOCK" then return end
local PetSpellInfo = GetSpellInfo
local GetSpellInfo = DrDamage.SafeGetSpellInfo
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local UnitExists = UnitExists
local UnitIsFriend = UnitIsFriend
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitIsUnit = UnitIsUnit
local math_min = math.min
local math_max = math.max
local select = select
local GetPetSpellBonusDamage = GetPetSpellBonusDamage
local GetSpellCritChanceFromIntellect = GetSpellCritChanceFromIntellect
local GetPrimaryTalentTree = GetPrimaryTalentTree
local GetMastery = GetMastery

local spells = { [GetSpellInfo(7814) or "Lash of Pain"] = true, [GetSpellInfo(54049) or "Shadow Bite"] = true, [GetSpellInfo(3110) or "Firebolt"] = true, }
function DrDamage:UpdatePetSpells()
	self:UpdateAB(spells)
end

function DrDamage:PlayerData()
	--Health updates
	self.PlayerHealth = { [1] = 0.251, [0.251] = GetSpellInfo(689) }
	self.TargetHealth = { [1] = 0.251, }
	--General
	--Drain Mana
	self.ClassSpecials[GetSpellInfo(5138)] = function()
		local value = not UnitIsFriend("player","target") and math_min(UnitPower("target",0), math_min(0.18 * UnitPowerMax("player",0), 0.09 * UnitPowerMax("target",0)))
		if value and value > 0 then
			return value, false, true
		else
			return "", false, true
		end
	end
--GENERAL
	self.Calculation["WARLOCK"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		--Set crits to 200%
		calculation.critM = calculation.critM + 0.5
		calculation.doubleCrits = true
		--General bonuses
		if calculation.group ~= "Pet" then
			--TODO: Verify
			if Talents["Death's Embrace"] then
				if UnitHealth("target") ~=0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.25 then
					calculation.dmgM = calculation.dmgM * ( 1 + 0.04 * Talents["Death's Embrace"] )
				end
			end
			if ActiveAuras["Metamorphosis"] == 0 then
				calculation.dmgM = calculation.dmgM * 1.2
			end
		end
		if not baseSpell.NoSchoolTalents then
			local spec = GetPrimaryTalentTree()
			local mastery = GetMastery()
			if spec == 1 then
				if calculation.school == "Shadow" or calculation.school == "Shadowflame" then
					--NOTE: Pets don't gain
					if calculation.group ~= "Pet" then
						if (calculation.playerLevel >= 80) and (baseSpell.eDot or baseSpell.Drain) then
							--Mastery is additive with Improved Corruption and Shadow Mastery
							--Shadow Mastery is multiplicative with Improved Corruption
							local mbonus = 0.13 + mastery * 0.0163 * 0.25
							calculation.dmgM = calculation.dmgM * 1.25
							if baseSpell.Drain then
								calculation.dmgM_Add = calculation.dmgM_Add + mbonus / 1.25
							else
								calculation.dmgM_dot_Add = calculation.dmgM_dot_Add + mbonus / 1.25
							end
						else
							if calculation.spellName == "Haunt" then
								calculation.bDmgM = calculation.bDmgM * 1.25
							else
								calculation.dmgM = calculation.dmgM * 1.25
							end
						end
					--else
						--NOTE: For some reason the tooltip is affected incorrectly
						--if calculation.base then
						--	calculation.bDmgM = calculation.bDmgM * 1.25
						--end
					end
				end
			elseif spec == 2 then
				if calculation.school == "Shadow" or calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						--Multiplicative 4.0
						calculation.dmgM = calculation.dmgM * 1.15
					end
					if calculation.playerLevel >= 80 and (calculation.group == "Pet" or (ActiveAuras["Metamorphosis"] == 0)) then
						--BUG: Mastery points don't currently apply
						calculation.dmgM = calculation.dmgM * (1.12 --[[+ mastery * 0.015 * 0.25--]])
						
						--[[
						if calculation.spellName == "Firebolt" then
							if calculation.base then
								BUG: Mastery points apply only to firebolt tooltip base damage
								calculation.bDmgM = calculation.bDmgM * (1.12 + mastery * 0.015 * 0.25)
							end
						else
							if calculation.base then
								calculation.bDmgM = calculation.bDmgM * 1.12
							end
						end
						--]]
					end
				end		
			elseif spec == 3 then
				if calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						if calculation.playerLevel >= 80 then
							--Multiplicative 4.0
							calculation.dmgM = calculation.dmgM * (1.25 + 0.1 + mastery * 0.0125 * 0.25)
						else
							calculation.dmgM = calculation.dmgM * 1.25
						end
					--else
					--	if calculation.base then
					--		calculation.bDmgM = calculation.bDmgM * (1.25 + 0.1 + mastery * 0.0125 * 0.25)
					--	end
					end
				end		
			end
		end
	end
--ABILITIES
	self.Calculation["Life Tap"] = function( calculation, _, Talents )
		--Additive - 4.0
		local amount = UnitHealthMax("player") * 0.15 * (1.20 + (Talents["Improved Life Tap"] or 0))
		calculation.minDam = amount
		calculation.maxDam = amount
	end
	self.Calculation["Drain Life"] = function( calculation, ActiveAuras, Talents )
		--Multiplicative - 4.0
		if ActiveAuras["Soul Siphon"] and Talents["Soul Siphon"] then
			calculation.dmgM = calculation.dmgM * (1 + math_min(4, ActiveAuras["Soul Siphon"]) * Talents["Soul Siphon"] * 0.03)
		end
		if ActiveAuras["Soulburn"] then
			calculation.castTime = 1.5
		end
		--TODO: Per Hit heal with Death's embrace included?
	end
	self.Calculation["Drain Soul"] = function ( calculation, ActiveAuras, Talents, spell )
		--Multiplicative - 4.0
		if ActiveAuras["Soul Siphon"] and Talents["Soul Siphon"] then
			calculation.dmgM = calculation.dmgM * (1 + math_min(4, ActiveAuras["Soul Siphon"]) * Talents["Soul Siphon"] * 0.03)
		end
		if UnitHealth("target") ~= 0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.25 then
			calculation.minDam = calculation.minDam * 2
			calculation.maxDam = calculation.maxDam * 2
		end
	end
	self.Calculation["Incinerate"] = function( calculation, ActiveAuras, Talents, spell )
		--Glyph of Incinerate (Additive - 4.0)
		if self:HasGlyph(56242) then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.05
		end
		if ActiveAuras["Immolate"] then
			calculation.minDam = 1.167 * calculation.minDam
			calculation.maxDam = 1.167 * calculation.maxDam
			calculation.SPBonus = 1.167 * calculation.SPBonus
			--TODO: Doesn't seem to apply...
			--calculation.dmgM = calculation.dmgM * (1 + (Talents["Fire and Brimstone"] or 0))
		end
		if ActiveAuras["Molten Core"] and Talents["Molten Core"] then
			--Additive 4.0
			calculation.dmgM_Add = calculation.dmgM_Add + 0.06 * Talents["Molten Core"]
		end
		if self:GetSetAmount( "T8" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
		if self:GetSetAmount( "T10" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	self.Calculation["Soul Fire"] = function( calculation, ActiveAuras, Talents, spell )
		if self:GetSetAmount( "T10" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 5
		end
		if Talents["Burning Embers"] then
			calculation.hybridCanCrit = false
			calculation.hybridDotDmg = self.spellInfo["Burning Embers"][1][1]
			calculation.SPBonus_dot = Talents["Burning Embers"] * 0.5
			calculation.dmgM_dot = calculation.dmgM_dot / calculation.dmgM
			calculation.eDuration = 7
			calculation.sTicks = 1
		end
	end
	self.Calculation["Chaos Bolt"] = function( calculation, ActiveAuras, Talents )
		if ActiveAuras["Immolate"] and Talents["Fire and Brimstone"] then
			calculation.dmgM = calculation.dmgM * (1 + Talents["Fire and Brimstone"])
		end
		--Glyph of Chaos Bolt (4.0)
		if self:HasGlyph(63304) then
			calculation.cooldown = calculation.cooldown - 2
		end
	end
	self.Calculation["Immolate"] = function( calculation )
		--Glyph of Immolate (4.0)
		if self:HasGlyph(56228) then
			calculation.dmgM_dot_Add = calculation.dmgM_dot_Add + 0.1
		end
		if self:GetSetAmount( "T8" ) >= 2 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		if self:GetSetAmount( "T9" ) >= 4 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
	end
	self.Calculation["Bane of Agony"] = function( calculation )
		--Glyph of Bane of Agony (4.0)
		if self:HasGlyph(56241) then
			calculation.eDuration = calculation.eDuration + 4
			--Total damage goes from 100% -> 133.2%. 28/24 increase is handled in the core, but the glyph gives high-end ticks so it gain more base damage.
			calculation.bDmgM = calculation.bDmgM * (133.2/(100*(28/24)))
		end
	end
	self.Calculation["Searing Pain"] = function( calculation, ActiveAuras, Talents )
		if Talents["Improved Searing Pain"] and UnitHealth("target") ~=0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.25 then
				calculation.critPerc = calculation.critPerc + Talents["Improved Searing Pain"]
		end
		if ActiveAuras["Soulburn"] then
			calculation.critPerc = 100
		end
	end
	self.Calculation["Corruption"] = function( calculation )
		if self:GetSetAmount( "T9" ) >= 4 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		if self:GetSetAmount( "T10" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	local Immolate = GetSpellInfo(348)
	self.Calculation["Conflagrate"] = function( calculation, ActiveAuras, Talents, spell )
		if self:GetSetAmount( "T8" ) >= 2 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		if self:GetSetAmount( "T9" ) >= 4 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		--Glyph of Conflagrate (4.0)
		if self:HasGlyph(63304) then
			calculation.cooldown = calculation.cooldown - 2
		end		
		--Glyph of Immolate (4.0)
		if self:HasGlyph(56228) then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
		calculation.SPBonus = 0.6 * self.spellInfo[Immolate][0].SPBonus_dot
		calculation.minDam = 0.6 * self.spellInfo[Immolate][1].hybridDotDmg
		calculation.maxDam = calculation.minDam
	end
	self.Calculation["Unstable Affliction"] = function( calculation )
		if self:GetSetAmount( "T8" ) >= 2 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.2
		end
		if self:GetSetAmount( "T9" ) >= 4 then
			calculation.dmgM_Add = calculation.dmgM_Add + 0.1
		end
	end
	self.Calculation["Shadow Bolt"] = function( calculation )
		if self:GetSetAmount( "T8" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end
		if self:GetSetAmount( "T10" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 5
		end
	end
	self.Calculation["Immolation Aura"] = function( calculation, ActiveAuras )
		if not ActiveAuras["Metamorphosis"] then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Demon Leap"] = function( calculation, ActiveAuras )
		if not ActiveAuras["Metamorphosis"] then
			calculation.dmgM = calculation.dmgM * 1.2
		end
	end	
	self.Calculation["Firebolt"] = function( calculation, ActiveAuras, Talents, spell )
		--calculation.critPerc = GetSpellCritChanceFromIntellect("pet") + calculation.spellCrit
		--Glyph of Imp (4.0)
		calculation.dmgM = calculation.dmgM * (1 + (self:HasGlyph(56248) and 0.2 or 0))
		if self:GetSetAmount( "T9" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end
		if Talents["Burning Embers"] then
			calculation.hybridCanCrit = false
			calculation.hybridDotDmg = self.spellInfo["Burning Embers"][1][1]
			calculation.dmgM_dot = calculation.dmgM_dot / calculation.dmgM
			calculation.SPBonus_dot = Talents["Burning Embers"] * 0.5
			calculation.SP_dot = calculation.SP - GetPetSpellBonusDamage()
			calculation.eDuration = 7
			calculation.sTicks = 1
		end	
		calculation.SP = GetPetSpellBonusDamage()
	end
	local shadowbite = {
		--Immolate, Corruption, Bane of Agony
		[GetSpellInfo(348)] = true, [GetSpellInfo(172)] = true, [GetSpellInfo(980)] = true, 
		--Unstable Affliction, Bane of Doom, Drain Soul
		[GetSpellInfo(30108)] = true, [GetSpellInfo(603)] = true, [GetSpellInfo(1120)] = true,
		--Drain Life, Seed of Corruption, 
		[GetSpellInfo(689)] = true, [GetSpellInfo(27243)] = true,
		--Also benefits from: Shadowflame
		--Doesn't benefit from: Hellfire, Rain of Fire
	}
	self.Calculation["Shadow Bite"] = function( calculation, ActiveAuras, Talents, spell )
		calculation.SP = GetPetSpellBonusDamage()
		--calculation.critPerc = GetSpellCritChanceFromIntellect("pet") + calculation.spellCrit
		if self:GetSetAmount( "T9" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end
		if UnitExists("pettarget") then
			local dots = 0
			for i = 1, 40 do
				local name, _, _, _, _, _, _, caster = UnitDebuff("pettarget",i)
				if name then
					if shadowbite[name] and caster and UnitIsUnit("player", caster) then
						dots = dots + 1
					end
				else break end
			end
			calculation.dmgM = calculation.dmgM * (1 + dots * 0.15)
		end
	end
	self.Calculation["Lash of Pain"] = function( calculation, ActiveAuras, Talents, spell )
		calculation.SP = GetPetSpellBonusDamage()
		--calculation.critPerc = GetSpellCritChanceFromIntellect("pet") + calculation.spellCrit
		--Glyph of Lash of Pain (4.0)
		calculation.dmgM = calculation.dmgM * (1 + (self:HasGlyph(70947) and 0.25 or 0))
		if self:GetSetAmount( "T9" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end
	end		
--SETS
	self.SetBonuses["T8"] = { 46135, 46136, 46137, 46139, 46140, 45417, 45419, 45420, 45421, 45422 }
	self.SetBonuses["T9"] = { 47798, 47799, 47800, 47801, 47802, 47783, 47784, 47785, 47786, 47787, 47782, 47778, 47780, 47779, 47781, 47788, 47789, 47790, 47791, 47792, 47803, 47804, 47805, 47806, 47807, 47797, 47796, 47795, 47794, 47793 }
	self.SetBonuses["T10"] = { 50240, 50241, 50242, 50243, 50244, 51230, 51231, 51232, 51233, 51234, 51205, 51206, 51207, 51208, 51209, }
--AURA
--Player
	--Demonic Soul (T7 proc)
	self.PlayerAura[GetSpellInfo(61595)] = { Spells = { "Shadow Bolt", "Incinerate" }, ModType = "critPerc", Value = 10, NoManual = true }
	--Devious Minds (T10 4p 10% damage)
	self.PlayerAura[GetSpellInfo(70840)] = { School = "Pet", Value = 0.1, NoManual = true }
	--Eradication (Affliction proc)
	self.PlayerAura[GetSpellInfo(47195)] = { Update = true }
	--Decimation (Demonology proc)
	self.PlayerAura[GetSpellInfo(63156)] = { Update = true, Spells = "Soul Fire" }
	--Improved Soul Fire (Destruction proc)
	self.PlayerAura[GetSpellInfo(85113)] = { Update = true }
	--Backlash (Destruction proc)
	self.PlayerAura[GetSpellInfo(34935)] = { Update = true, Spells = { "Incinerate", "Shadow Bolt" } }	
	--Empowered Imp (Destruction proc)
	self.PlayerAura[GetSpellInfo(47283)] = { Update = true, Spells = "Soul Fire" }
	--Molten Core (Demonology proc)
	self.PlayerAura[GetSpellInfo(47383)] = { Spells = "Incinerate", ActiveAura = "Molten Core", ID = 47383 }	
	--Metamorphosis
	self.PlayerAura[GetSpellInfo(59672)] = { ActiveAura = "Metamorphosis", Index = true, ID = 59672 }
	--Soulburn
	self.PlayerAura[GetSpellInfo(74434)] = { ActiveAura = "Soulburn", Spells = { "Searing Pain", "Soul Fire", "Drain Life" }, ID = 74434 }
	--Soulburn: Searing Pain
	self.PlayerAura[GetSpellInfo(79440)] = { Spells = "Searing Pain", ModType = "critPerc", Value = 50, ID = 79440 }
	--Demon Soul: Imp 
	--TODO: Hellfire? Rain of Fire?
	self.PlayerAura[GetSpellInfo(79459)] = { Spells = { "Searing Pain", "Soul Fire", "Incinerate", "Shadow Bolt", "Chaos Bolt" }, ModType = "critM", Apps = 3, Value = 0.1, ID = 79459 }
	--Demon Soul: Succubus
	self.PlayerAura[GetSpellInfo(79463)] = { Spells = "Shadow Bolt", Value = 0.1, ID = 79463 }
	--Demon Soul: Felhunter
	self.PlayerAura[GetSpellInfo(79460)] = { School = "Shadow", ID = 79460, Not = "Pet", ModType =
		function( calculation )
			if calculation.spellName == "Drain Life" or calculation.spellName == "Drain Soul" then
				calculation.dmgM = calculation.dmgM * 1.2
			else
				calculation.dmgM_dot = calculation.dmgM_dot * 1.2
			end
		end
	}
	--TODO: Demon Soul: Felguard. Does API handle it?
	
--Target
	--Immolate
	self.TargetAura[GetSpellInfo(348)] = { ActiveAura = "Immolate", Ranks = 11, Spells = { "Incinerate", "Conflagrate", "Chaos Bolt" }, SelfCast = true, ID = 348 }
	--Curse of Gul'dan
	self.TargetAura[GetSpellInfo(86000)] = { School = "Pet", ID = 86000, ModType = "spellCrit", Value = 10 }
	--Soul Siphon
		--Corruption
		self.TargetAura[GetSpellInfo(172)] = 	{ ActiveAura = "Soul Siphon", Spells = { "Drain Life", "Drain Soul" }, SelfCast = true, NoManual = true }
		--Bane of Agony
		self.TargetAura[GetSpellInfo(980)] = 	self.TargetAura[GetSpellInfo(172)]
		--Bane of Doom
		self.TargetAura[GetSpellInfo(603)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Weakness
		self.TargetAura[GetSpellInfo(702)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Tongues
		self.TargetAura[GetSpellInfo(1714)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Exhaustion
		self.TargetAura[GetSpellInfo(18223)] = 	self.TargetAura[GetSpellInfo(172)]
		--Unstable Affliction
		self.TargetAura[GetSpellInfo(30108)] = 	self.TargetAura[GetSpellInfo(172)]
		--Seed of Corruption
		self.TargetAura[GetSpellInfo(27243)] = 	self.TargetAura[GetSpellInfo(172)]
		--Fear
		self.TargetAura[GetSpellInfo(5782)] = 	self.TargetAura[GetSpellInfo(172)]
		--Howl of Terror
		self.TargetAura[GetSpellInfo(5484)] = 	self.TargetAura[GetSpellInfo(172)]
--Custom
	--Curse of the Elements (debuff added in Aura.lua)
	self.TargetAura[GetSpellInfo(1490)].ActiveAura = "Soul Siphon"
	--Demon Armor
	self.PlayerAura[GetSpellInfo(687)] = { School = "Leech", ID = 687, ModType =
		function( calculation, _, Talents )
				calculation.leechBonus = (calculation.leechBonus or 0) * (1.2 + (Talents["Demonic Aegis"] or 0))
		end
	}
	--Backdraft
	self.PlayerAura[GetSpellInfo(47258)] = { NoManual = true, ModType =
		function( calculation, _, Talents )
			if Talents["Backdraft"] then
				calculation.haste = calculation.haste * (1 + Talents["Backdraft"])
			end
		end
	}
	--Haunt
	self.TargetAura[GetSpellInfo(48181)] = { School = "Shadow", SelfCast = true, ID = 48181, Not = { "Pet", "Bane of Doom" }, ModType =
		function( calculation, ActiveAuras, Talents )
			--Glyph of Haunt (4.0)
			if calculation.spellName == "Drain Life" or calculation.spellName == "Drain Soul" then
				--Multiplicative - 4.0
				calculation.dmgM = calculation.dmgM * (1.2 + (self:HasGlyph(63302) and 0.03 or 0))
			else
				--Multiplicative - 4.0
				calculation.dmgM_dot = calculation.dmgM_dot * (1.2 + (self:HasGlyph(63302) and 0.03 or 0))
			end
			if Talents["Soul Siphon"] then
				--Verified - 4.0
				ActiveAuras["Soul Siphon"] = (ActiveAuras["Soul Siphon"] or 0) + 1
			end
		end
	}
	--Shadow Embrace
	self.TargetAura[GetSpellInfo(32386)] = { School = "Shadow", SelfCast = true, ID = 32386, Apps = 3, Not = { "Pet", "Bane of Doom" }, ModType =
		function( calculation, ActiveAuras, Talents, _, apps )
			if Talents["Shadow Embrace"] then
				if calculation.spellName == "Drain Life" or calculation.spellName == "Drain Soul" then
					--Multiplicative 4.0
					calculation.dmgM = calculation.dmgM * (1 + Talents["Shadow Embrace"] * apps)
				else
					--Multiplicative 4.0
					calculation.dmgM_dot = calculation.dmgM_dot * (1 + Talents["Shadow Embrace"] * apps)
				end
			end
			if Talents["Soul Siphon"] then
				--Verified 4.0
				ActiveAuras["Soul Siphon"] = (ActiveAuras["Soul Siphon"] or 0) + 1
			end
		end
	}
	
	--TODO: Check UA, Haunt, Demon Leap, Immolation Aura, Soul Swap, Hand of Gul'Dan, Fel Flame

	self.spellInfo = {
		[GetSpellInfo(172)] = {
					["Name"] = "Corruption",
					["ID"] = 172,
					--["Base"] = function() return self:ScanTooltip(172, false, false, 18) end,
					["Data"] = { 0.153, 0, 0.176 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 6, eDot = true, eDuration = 18, sTicks = 3 },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(686)] = {
					["Name"] = "Shadow Bolt",
					["ID"] = 686,
					--["Base"] = function() return self:ScanTooltip(686, true) end,
					["Data"] = { 0.62, 0.11, 0.754 },
					[0] = { School = { "Shadow", "Destruction" } },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(1454)] = {
					["Name"] = "Life Tap",
					["ID"] = 1454,
					[0] = { School = { "Shadow", "Utility", }, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(6229)] = {
					["Name"] = "Shadow Ward",
					["ID"] = 6229,
					--["Base"] = function() return self:ScanTooltip(6229, false, false, 30) end,
					["Data"] = { 3.69, 0 },
					[0] = { School = { "Shadow", "Absorb" }, SPBonus = 0.807, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true, },
					[1] = { 0, 0 },
		},
		[GetSpellInfo(980)] = {
					["Name"] = "Bane of Agony",
					["ID"] = 980,
					--["Base"] = function() return self:ScanTooltip(980, false, false, 24) end,
					["Data"] = { 0.133, 0, 0.088 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 12, eDot = true, eDuration = 24, sTicks = 2, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(603)] = {
					["Name"] = "Bane of Doom",
					["ID"] = 603,
					--["Base"] = function() return self:ScanTooltip(603, false, false, 15) end,
					["Data"] = { 2.024, 0, 0.88  },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 4, eDot = true, eDuration = 60, sTicks = 15 },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(6789)] = {
					["Name"] = "Death Coil",
					["ID"] = 6789,
					--["Base"] = function() return self:ScanTooltip(6789, false, false, 10) end,
					["Data"] = { 0.784, 0, 0.188 },
					[0] = { School = { "Shadow", "Affliction", "Leech" }, Cooldown = 120, Leech = 3, NoDoom = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(689)] = {
					["Name"] = "Drain Life",
					["ID"] = 689,
					--["Base"] = function() return self:ScanTooltip(689, false, false, 5) end,
					["Data"] = { 0.114, 0, 0.172  },
					[0] = { School = { "Shadow", "Affliction" }, Hits = 3, sTicks = 1, Channeled = 3, Drain = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(1120)] = {
					["Name"] = "Drain Soul",
					["ID"] = 1120,
					--["Base"] = function() return self:ScanTooltip(1120, false, false, 15) end,
					["Data"] = { 0.08, 0, 0.378  },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 5, sTicks = 3, Channeled = 15, Drain = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(5676)] = {
					["Name"] = "Searing Pain",
					["ID"] = 5676,
					--["Base"] = function() return self:ScanTooltip(5676, true) end,
					["Data"] = { 0.322, 0.17, 0.378 },
					[0] = { School = { "Fire", "Destruction" }, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(6353)] = {
					["Name"] = "Soul Fire",
					["ID"] = 6353,
					--["Base"] = function() return self:ScanTooltip(6353, true) end,
					["Data"] = { 2.543, 0.225, 0.628 },
					[0] = { School = { "Fire", "Destruction" }, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(17877)] = {
					["Name"] = "Shadowburn",
					["ID"] = 17877,
					--["Base"] = function() return self:ScanTooltip(17877, true) end,
					["Data"] = { 0.714, 0.11, 1.056 },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 15, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(348)] = {
					["Name"] = "Immolate",
					["ID"] = 348,
					--["Base"] = function() 
					--	local value1 = self:ScanTooltip(348, false, 1, 15)
					--	local value2 = self:ScanTooltip(348, false, 2, 15)
					--	local min = math_min(value1,value2)
					--	local dot = math_max(value1,value2)
					--	return min, min, dot
					--end,
					["Data"] = { 0.692, 0, 0.22, 0.439, 0, 0.176  },
					[0] = { School = { "Fire", "Destruction" }, Hits_dot = 5, eDuration = 15, sTicks = 3, },
					[1] = { 0, 0, hybridDotDmg = 0, },
		},
		[GetSpellInfo(1949)] = {
					["Name"] = "Hellfire",
					["ID"] = 1949,
					--Verify it works for all locales
					--["Base"] = function() return self:ScanTooltip(1949, false, 2, 15) end,
					["Data"] = { 0.332, 0, 0.095 },
					[0] = { School = { "Fire", "Destruction" }, Hits = 15, Channeled = 15, sTicks = 1, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(5740)] = {
					["Name"] = "Rain of Fire",
					["ID"] = 5740,
					--["Base"] = function() return self:ScanTooltip(5740, false, false, 8) end,
					["Data"] = { 0.638, 0, 0.191 },
					[0] = { School = { "Fire", "Destruction" }, Hits = 4, Channeled = 8, sTicks = 2, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(30108)] = {
					["Name"] = "Unstable Affliction",
					["ID"] = 30108,
					--["Base"] = function() return self:ScanTooltip(30108, false, false, 15) end,
					["Data"] = { 0.232, 0, 0.2 },
					[0] = { School = { "Shadow", "Affliction", }, Hits = 5, eDot = true, eDuration = 15, sTicks = 3, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(17962)] = {
					["Name"] = "Conflagrate",
					["ID"] = 17962,
					[0] = { School = { "Fire", "Destruction" }, Cooldown = 10, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(27243)] = {
					["Name"] = "Seed of Corruption",
					["ID"] = 27243,
					--["Base"] = function(spell)
					--	local min, max = self:ScanTooltip(27243, true)
					--	local dot = self:ScanTooltip(27243, false, 1, 18)
					--	local dotCap = self:ScanTooltip(27243, false, 2, 18)
					--	spell.dotCap = dotCap
					--	return min, max, dot
					--end,
					["Data"] = { 0.638, 0.15, 0.191, 0.252, 0, 0.25  },
					["Data2"] = function(baseSpell, spell, playerLevel) 
						baseSpell.Cap = 1.761 * self.Scaling[playerLevel]
						baseSpell.Cap_SPBonus = 0.143
					end,
					[0] = { School = { "Shadow", "Affliction", }, Hits_dot = 6, eDuration = 18, sTicks = 3, NoDotAverage = true, AoE = true },
					[1] = { 0, 0, hybridDotDmg = 0 },
		},
		[GetSpellInfo(30283)] = { 
					["Name"] = "Shadowfury",
					["ID"] = 30283,
					--["Base"] = function() return self:ScanTooltip(30283, true) end,
					["Data"] = { 0.783, 0.175, 0.214 },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 20, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(29722)] = {
					["Name"] = "Incinerate",
					["ID"] = 29722,
					--Make sure it works in all locales
					--["Base"] = function(spell) return self:ScanTooltip(29722, true, 1) end,
					["Data"] = { 0.573, 0.15, 0.539 },
					[0] = { School = { "Fire", "Destruction" }, },
					[1] = { 0, 0, 0, 0 },
		},
		[GetSpellInfo(47897)] = {
					["Name"] = "Shadowflame",
					["ID"] = 47987,
					--["Base"] = function() return self:ScanTooltip(47897, true) end,
					["Data"] = { 0.727, 0.09, 0.102 },
					[0] = { School = { "Shadow", "Destruction" }, Cooldown = 12, },
					[1] = { 0, 0, },
			["Secondary"] = {
					["Name"] = "Shadowflame",
					["ID"] = 47897,
					--Make sure this works for all locales
					--["Base"] = function() return 0, 0, (self:ScanTooltip(47897, false, 3, 6)) end,
					["Data"] = { 0, 0, 0, 0.169, 0, 0.2  },
					[0] = { School = { "Fire", "Destruction" }, Hits_dot = 3, eDuration = 6, sTicks = 2, Cooldown = 12 },
					[1] = { 0, 0, hybridDotDmg = 0 },
			},
		},
		[GetSpellInfo(48181)] = {
					["Name"] = "Haunt",
					["ID"] = 48181,
					--["Base"] = function() return self:ScanTooltip(48181, false, false, 12) end,
					["Data"] = { 0.737, 0, nil },
					[0] = { School = { "Shadow", "Affliction" }, SPBonus = 0.53625, Cooldown = 8 },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(50796)] = {
					["Name"] = "Chaos Bolt",
					["ID"] = 50796,
					--["Base"] = function() return self:ScanTooltip(50796, true) end,
					["Data"] = { 1.547, 0.238, 0.628 },
					[0] = { School = { "Fire", "Destruction" }, Unresistable = true, Cooldown = 12, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(50589)] = {
					["Name"] = "Immolation Aura",
					["ID"] = 50589,
					--["Base"] = function() return self:ScanTooltip(50589, false, false, 15) end,
					--["Data"] = { 0, 0, 0.143 },
					[0] = { School = "Fire", SPBonus = 0.143, Channeled = 15, Hits = 15, sTicks = 1, Cooldown = 30, AoE = true, },
					[1] = { 251, 251, },
		},
		[GetSpellInfo(54785)] = {
					["Name"] = "Demon Leap",
					["ID"] = 54785,
					--["Base"] = function() return self:ScanTooltip(54785, true) end,
					["Data"] = { 2.514, 0.17, 0.214, },
					[0] = { School = "Shadow", AoE = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(3110)] = {
					["Name"] = "Firebolt",
					["ID"] = 3110,
					--["Base"] = function() 
					--				local min, max = self:ScanTooltip(3110)
					--				return min, max, nil, 1, 0.9099
					--			end,
					["Data"] = { 0.123, 0.11, nil },
					[0] = { School = { "Fire", "Pet" }, SPBonus = 0.657, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(54049)] = {
					["Name"] = "Shadow Bite",
					["ID"] = 54049,
					--["Base"] = function() 
					--				local min, max = self:ScanTooltip(54049)
					--				return min, max, nil, 1, 0.835 * 2.39, 2.39
					--			end,
					--Tooltip displays wrong base values, range is halved
					["Data"] = { 0.163, 0.35 / 2, nil },			
					[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.614, Cooldown = 6, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(7814)] = {
					["Name"] = "Lash of Pain",
					["ID"] = 7814,
					--["Base"] = function() 
					--				local min, max = self:ScanTooltip(7814)
					--				return min, max, nil, 1, 0.903 * 1.429, 1.429
					--			end,
					--Tooltip displays wrong base values, multiplier of 1.5 seems to give correct values
					["Data"] = { 0.201 * 1.5, 0.16 / 1.5, nil },			
					[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.612, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(86121)] = {
					["Name"] = "Soul Swap",
					["ID"] = 86121,
					--["Base"] = function() return self:ScanTooltip(86121, false, false, 20) end,
					["Data"] = { 0.174, 0, 0.2 },
					[0] = { School = { "Shadow", "Affliction" }, },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(71521)] = {
					["Name"] = "Hand of Gul'Dan",
					["ID"] = 71521,
					--["Base"] = function() return self:ScanTooltip(71521, true) end,
					["Data"] = { 1.593, 0.166, 0.968 },
					[0] = { School = "Shadow", Cooldown = 12, AoE = true },
					[1] = { 0, 0, },
		},
		[GetSpellInfo(77799)] = {
					["Name"] = "Fel Flame",
					["ID"] = 77799,
					["Base"] = function() return self:ScanTooltip(77799, true) end,
					["Data"] = { 0.248, 0.15, 0.302 },
					[0] = { School = "Shadowflame", Double = { 3, 6 }, },
					[1] = { 0, 0, },
		},
		["Burning Embers"] = {
					["Name"] = "Burning Embers",
					["ID"] = 85112,
					--["Base"] = function() 
					--	local min, max = self:ScanTooltip(85112, false, false, 7)
					--	return min * 7, max * 7, nil, 1
					--end,
					["Data"] = { 0.174, 0, nil },
					[0] = { School = "Fire", SPBonus = 1, NoGlobalMod = true, NoSchoolTalents = true },
					[1] = { 0, 0 },
		},	
	}
	self.talentInfo = {
	--AFFLICTION
		--Doom and Gloom
		[GetSpellInfo(18827)] = { 	[1] = { Effect = 4, Spells = { "Bane of Agony", "Bane of Doom" }, ModType = "critPerc" }, },
		--Improved Life Tap
		[GetSpellInfo(18182)] = { 	[1] = { Effect = 0.1, Spells = "Life Tap", ModType = "Improved Life Tap" }, },		
		--Improved Corruption (additive - 4.0)
		[GetSpellInfo(17810)] = {	[1] = { Effect = 0.04, Spells = "Corruption", ModType = "dmgM_dot_Add" }, },
		--Soul Siphon
		[GetSpellInfo(17804)] = { 	[1] = { Effect = 1, Spells = { "Drain Soul", "Drain Life" }, ModType = "Soul Siphon" }, },
		--Shadow Embrace (multiplicative - 4.0)
		[GetSpellInfo(32385)] = {	[1] = { Effect = { 0.03, 0.04, 0.05 }, Spells = "Shadow", Not = "Pet", ModType = "Shadow Embrace" }, },
		--Death's Embrace (multiplicative - 4.0)
		[GetSpellInfo(47198)] = {	[1] = { Effect = 1, Spells = { "Shadow", "Shadowflame" }, Not = "Pet", ModType = "Death's Embrace", }, },		
		--Everlasting Affliction
		[GetSpellInfo(47201)] = {	[1] = { Effect = 5, Spells = { "Corruption", "Seed of Corruption", "Unstable Affliction" }, ModType = "critPerc" }, },
		--Pandemic
		[GetSpellInfo(85099)] = {	[1] = { Effect = -0.25, Spells = { "Bane of Agony", "Bane of Doom" }, ModType = "castTime" }, },
	--DEMONOLOGY
		--Dark Arts (additive? - doesn't matter)
		[GetSpellInfo(85284)] = {	[1] = { Effect = 0.05, Spells = "Shadow Bite", }, },
		--Demonic Aegis
		[GetSpellInfo(30143)] = { 	[1] = { Effect = 0.05, Spells = "Leech", ModType = "Demonic Aegis" }, },		
		--Molten Core (additive - 4.0)
		[GetSpellInfo(47245)] = {	[1] = { Effect = 1, Spells = "Incinerate", ModType = "Molten Core", }, },
		--Cremation (additive - 4.0)
		[GetSpellInfo(85104)] = { 	[1] = { Effect = 0.15, Spells = "Hellfire", }, },		
		--Demonic Pact (multiplicative - 4.0)
		[GetSpellInfo(47236)] = {	[1] = { Effect = 0.02, Spells = "All", Not = "Pet", Multiply = true }, },
	--DESTRUCTION:
		--Shadow and Flame (additive - 4.0 - ?)
		[GetSpellInfo(17793)] = {	[1] = { Effect = 0.04, Spells = { "Shadow Bolt", "Incinerate" } }, },
		--Improved Immolate (additive?)
		[GetSpellInfo(17815)] = { 	[1] = { Effect = 0.1, Spells = { "Immolate", "Conflagrate" }, }, },
		--Improved Searing Pain
		[GetSpellInfo(17927)] = { 	[1] = { Effect = 20, Spells = "Searing Pain", ModType = "Improved Searing Pain", }, },
		--Backdraft
		[GetSpellInfo(47258)] = { 	[1] = { Effect = 0.1, Spells = { "Shadow Bolt", "Chaos Bolt", "Incinerate" }, ModType = "Backdraft", }, },
		--Burning Embers
		[GetSpellInfo(91986)] = { 	[1] = { Effect = 1, Spells = { "Firebolt", "Soul Fire" }, ModType = "Burning Embers", }, },
		--Fire and Brimstone (multiplicative?)
		[GetSpellInfo(47266)] = {	[1] = { Effect = 5, Spells = "Conflagrate", ModType = "critPerc", },
									[2] = { Effect = 0.02, Spells = { "Incinerate", "Chaos Bolt" }, ModType = "Fire and Brimstone" }, },		
	}
end